//---------------------------------------------------------------------------
//	$Archive: /BCB/Source/Hofi/HNwVcl5/hnwbchklstbox.h $
//	$Author: Hofi $
//	$Modtime: 00-11-15 23:44 $		$Revision: 4 $
//---------------------------------------------------------------------------
//
//
/*	$History: hnwbchklstbox.h $
 *
 * *****************  Version 4  *****************
 * User: Hofi         Date: 00-11-28   Time: 12:14
 * Updated in $/BCB/Source/Hofi/NW
 *
 * *****************  Version 3  *****************
 * User: Hofi         Date: 00-11-06   Time: 21:33
 * Updated in $/BCB/Source/Hofi/NW
 *  - Mentes elotti szinkron
 *
 * *****************  Version 2  *****************
 * User: Hofi         Date: 8/10/00    Time: 8:21p
 * Updated in $/BCB/Source/Hofi/NW
*/
//
//	$NoKeywords: $
//---------------------------------------------------------------------------
//
/* @doc EXTERNAL INTERNAL
 *
 * @module hnwbchklstbox.h - HNwVcl5.BPL Chapter X |
 *
 * Contains Definitions, classes, and prototypes of the Netware visual interface
 * component HNWBCheckListBox
 *
 * Copyright (c)2000-2001 MeMyselfAndI, All Rights Reserved
 *
 * Hofi (hofi@fw.hu)
*/
//---------------------------------------------------------------------------

#ifndef hnwbchklstboxH
#define hnwbchklstboxH
//---------------------------------------------------------------------------

#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include <RXCtrls.hpp>
#include <HRxCheckListBox.h>

#include <hnwcalls.h>
//---------------------------------------------------------------------------

// @type THNWObjTypes |
// Set\<<c HNWBObjType>, otUnknown, otWild> |
// Type Netware objects to include in the list
typedef Set<HNWBObjType, otUnknown, otWild>  THNWObjTypes;
// @type THNWBEnumObjFunc |
// typedef void __fastcall (__closure * THNWBEnumObjFunc)( nuint32 objectID, pnstr8 objectName, nuint16 objectType, nuint8 objectHasProperties, nuint8 objectFlag, nuint8 objectSecurity, |
// Type Netware objects enumerator filter function
typedef void __fastcall (__closure * THNWBEnumObjFunc)( nuint32 objectID,
 pnstr8 objectName, nuint16 objectType,
 nuint8 objectHasProperties, nuint8 objectFlag, nuint8 objectSecurity,
 void* handlerObject);
// @type THNWBEnumObjTypesChanged |
// typedef void __fastcall (__closure * THNWBEnumObjTypesChanged) |
// Type of pointer of a member function called when type of Netware objects to list changed
typedef void __fastcall (__closure * THNWBEnumObjTypesChanged)(
 THNWObjTypes value);
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

//
//@class CheckListBox component can show netware object of selected types.
//
//@base public | HRxCheckListBox
//
class PACKAGE HNWBCheckListBox : public HRxCheckListBox {

typedef ::HRxCheckListBox Inherited;																						// type Inherited | HRxCheckListBox | Typefor using base class inherited tags

friend bool _HFUNC DefObjEnumFunc( nuint32 objectID, pnstr8 objectName,
										nuint16 objectType,
										nuint8 objectHasProperties, nuint8 objectFlag,
										nuint8 objectSecurity, void* handlerObject);

private:
	THNWBEnumObjFunc fOnObjectAdd;																								// @cmember The real data of <op .OnObjectAdd>, see there
	THNWBEnumObjTypesChanged fOnObjectTypesChanged;                               // @cmember The real data of <op .OnObjectTypesChanged>, see there
	THNWObjTypes fObjectTypes;                                                    // @cmember The real data of <op .objectTypes>, see there

	void __fastcall SetObjectTypes(THNWObjTypes value);														// @cmember <op ::objectTypes> property setter function
	void __fastcall Activate(void);                                               // @cmember Activates the control on its form


protected:

	virtual void __fastcall DoObjectTypesChanged(THNWObjTypes value);							// @cmember Does the work, refreshing the netware object list based on <op: objectTypes>

public:

	static const THNWObjTypes defHNWObjTypes;																			// @cmember Default value of the <op ::objectType>

	__fastcall HNWBCheckListBox(TComponent* Owner);																// @cmember Constructor
	virtual __fastcall ~HNWBCheckListBox();                                       // @cmember virtual Destructor

	virtual void __fastcall RefreshList(void);																		// @cmember Refreshing the list of available Netware objects

__published:
	__property THNWBEnumObjFunc OnObjectAdd  = { read = fOnObjectAdd,							// @prop <c THNWBEnumObjFunc> | OnObjectAdd | points to the user event handler of a <c THNWBEnumObjFunc><nl>(read = <md ::fOnObjectAdd>, write = <md ::fOnObjectAdd>)
															write = fOnObjectAdd };
	__property THNWBEnumObjTypesChanged OnObjectTypesChanged  = {									// @prop <c THNWBEnumObjTypesChanged> | OnObjectTypesChanged | points to the user event handler of a <c THNWBEnumObjTypesChanged><nl>(read = <md ::fOnObjectTypesChanged>, write = <md ::fOnObjectTypesChanged>)
																			read = fOnObjectTypesChanged,
																			write = fOnObjectTypesChanged };

	__property THNWObjTypes objectTypes  = { read = fObjectTypes,                 // @prop <c THNWObjTypes> | objectTypes | Contains the types of Netware object to show in te list<nl>(read = <md ::fobjectTypes>, write = <md ::fobjectTypes>, stored = true)
													write = SetObjectTypes, stored = true };

	__property CheckKind = { stored = true, default = ckCheckMarks };							// @prop TCheckKind | CheckKind | Overriding the the default value of the inherited property<nl>(stored = true, default = ckCheckMarks)
	__property Sorted = { default = true };																				// @prop bool | Sorted | Overriding the the default value of the inherited property<nl>(default = true)
	__property Style = { default = lbOwnerDrawFixed, stored = true };             // @prop bool | Style | Overriding the the default value of the inherited property<nl>(stored = true, default = lbOwnerDrawFixed)
	__property ItemHeight = { default = 16, stored = true };											// @prop bool | ItemHeight | Overriding the the default value of the inherited property<nl>(stored = true, default = 16)
	__property Items = { stored = false };																				// @prop bool | Items | Overriding the the default value of the inherited property<nl>(stored = false)
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

