//---------------------------------------------------------------------------
//	$Archive: /Mylib/Include/hnwcalls.h $
//	$Author: Hofi $
//	$Modtime: 8/10/00 6:16p $		$Revision: 1 $
//---------------------------------------------------------------------------
//
//
/*	$History: hnwcalls.h $
 *
 * *****************  Version 1  *****************
 * User: Hofi         Date: 8/10/00    Time: 6:57p
 * Created in $/Mylib/Include
 * Header fileok
*/
//
//	$NoKeywords: $
//---------------------------------------------------------------------------

#if !defined(__included_hnwcalls_h)
#define __included_hnwcalls_h
/*--------------------------------------------------------------------------*/

#if defined(_Windows)
# include <windows.h>																														/* NE VIDD INNEN EL !!!! */
#endif
#include <hdefs.h>
#include <nwcalls.h>
//---------------------------------------------------------------------------

#if defined(__cplusplus)
extern "C" {
#endif
//---------------------------------------------------------------------------

typedef bool (* HNWEnumGroupsUserInFunc) ( const char * pGroupName,
 void* handlerObject);
typedef bool (* HNWEnumObjFunc)(nuint32 objectID, pnstr8 objectName,
 nuint16 objectType,
 nuint8 objectHasProperties, nuint8 objectFlag, nuint8 objectSecurity,
 void* handlerObject);
typedef void * HNWEnumHandlerObject;
//---------------------------------------------------------------------------

#include <preenums.h>
enum HNWBObjType {
  otUnknown,
  otUser,
  otUserGroup,
  otPrintQueue,
  otFileServer,
  otJobServer,
  otGateway,
  otPrintServer,
  otArchiveQueue,
  otArchiveServer,
  otJobQueue,
  otAdministration,
  otNasSnaGateway,
  otRemoteBridgeServer,
  otTcpIpGateway,
  otTreeName,
  otTimeSyncServer,
  otArchiveServerDynSap,
  otAdvertPrintServer,
  otBtrieveVap,
  otPrintQueueUser,
  otWild,
};
#include <posenums.h>

//---------------------------------------------------------------------------

extern nuint16 hNWBObjTypes[];
extern const char *hNWBObjTypeTexts[];
extern const int numOfHNWBObjTypeTexts;
//---------------------------------------------------------------------------

extern bool 				_HFUNC HNWIsInitialized(void);
extern NWCCODE 			_HFUNC HNWCallsInit(nptr in, nptr out);
extern NWCCODE 			_HFUNC HNWCallsTerm(nptr res);

extern HNWBObjType	_HFUNC GetHNWBObjType(nuint16 type);
extern bool 				_HFUNC HNWIsKnownObject(nuint16 objectType);

extern pnstr 				_HFUNC HNWGetFullNameFromShortName(const char * serverName,
														const char * userShortName, pnstr fullName,
														nint16 fLen);
extern NWCONN_NUM 	_HFUNC HNWGetConnectionNumber(const char * serverName);
extern pnstr 				_HFUNC HNWGetUserName(const char * serverName,
														pnstr userName, nint16 uLen);
extern pnstr 				_HFUNC HNWGetDefaultServerName( pnstr serverName,
														nint16 sLen);
extern NWINET_ADDR* _HFUNC HNWGetINetAddr(const char *serverName,
														NWINET_ADDR N_FAR  *pInetAddr);
extern NWCCODE 			_HFUNC HNWBEnumObjects(const char *serverName,
														HNWBObjType objType, HNWEnumObjFunc pEnumFunc,
														HNWEnumHandlerObject pEnumHandlerObject);
extern NWCCODE			_HFUNC HNWBEnumGroupsUserIn(const  char * pServerName,
														const char * pUserName,
														HNWEnumGroupsUserInFunc pEnumFunc,
														HNWEnumHandlerObject pEnumHandlerObject);
extern bool 				_HFUNC HNWBIsMemberOf(const char * pServerName,
														const char * pUserName, const char * pGroupStr);
//---------------------------------------------------------------------------
#if defined(__cplusplus)
}
#endif

//---------------------------------------------------------------------------
#endif /* __included_hnwcalls_h */
//---------------------------------------------------------------------------

